/*1:*/
#line 39 "parsetree.w"
#ifndef PARSE_TYPES_H
#define PARSE_TYPES_H/*6:*/
#line 146 "parsetree.w"
#include "buffer.h" /*:6*//*37:*/
#line 612 "parsetree.w"
#include "sl_list.h" /*:37*//*100:*/
#line 1611 "parsetree.w"
#include "axis-types.h" /*:100*//*145:*/
#line 2218 "parsetree.w"
#include "bitset.h"/*:145*/
#line 41 "parsetree.w"

struct YYLTYPE;

namespace atlas
{
namespace interpreter
{/*4:*//*5:*/
#line 139 "parsetree.w"
struct expr;/*:5*//*7:*/
#line 153 "parsetree.w"
struct source_location
{unsigned int start_line;
unsigned short extent,first_col,last_col;
id_type file;
source_location(const YYLTYPE&loc);
source_location():start_line(~0u){}

source_location
(const source_location&left,const source_location&right);

bool undefined()const{return start_line==~0u;}
};/*:7*//*38:*/
#line 627 "parsetree.w"
typedef containers::simple_list<expr>expr_list;
typedef containers::sl_node<expr> *raw_expr_list;


typedef containers::weak_sl_list_const_iterator<expr>wel_const_iterator;
typedef containers::weak_sl_list_iterator<expr>wel_iterator;/*:38*//*52:*/
#line 828 "parsetree.w"
typedef struct application_node*app;/*:52*//*81:*/
#line 1313 "parsetree.w"
typedef containers::simple_list<struct id_pat>patlist;
typedef containers::sl_node<struct id_pat> *raw_patlist;

struct raw_id_pat
{id_type name;
unsigned char kind;

raw_patlist sublist;
};
struct id_pat
{id_type name;
unsigned char kind;

patlist sublist;

id_pat():name(),kind(0x0),sublist(){}
explicit id_pat(const raw_id_pat&x)
:name(x.name),kind(x.kind)
,sublist((kind&0x2)==0?nullptr:x.sublist)
{}
id_pat(id_type n):name(n),kind(0x1),sublist(){}

id_pat(patlist&&l):name(),kind(0x2),sublist(std::move(l)){}

id_pat(id_type n,unsigned char k,patlist&&l)
:name(n),kind(k),sublist(std::move(l)){}

id_pat(const id_pat&x)=delete;
id_pat&operator=(const id_pat&x)=delete;
id_pat(id_pat&&x)=default;
id_pat&operator=(id_pat&&x)=default;
raw_id_pat release()
{return{name,kind,sublist.release()};}
};/*:81*//*88:*/
#line 1436 "parsetree.w"
typedef struct let_expr_node*let;/*:88*//*103:*/
#line 1631 "parsetree.w"
typedef struct lambda_node*lambda;
typedef struct rec_lambda_node*rec_lambda;/*:103*//*114:*/
#line 1801 "parsetree.w"
typedef struct conditional_node*cond;/*:114*//*132:*/
#line 2058 "parsetree.w"
typedef struct discrimination_node*disc;/*:132*//*144:*/
#line 2210 "parsetree.w"
typedef struct while_node*w_loop;
typedef struct for_node*f_loop;
typedef struct cfor_node*c_loop;/*:144*//*155:*/
#line 2395 "parsetree.w"
typedef struct subscription_node*sub;
typedef struct slice_node*slc;/*:155*//*165:*/
#line 2528 "parsetree.w"
typedef struct cast_node*cast;/*:165*//*175:*/
#line 2596 "parsetree.w"
typedef struct op_cast_node*op_cast;/*:175*//*185:*/
#line 2665 "parsetree.w"
typedef struct assignment_node*assignment;/*:185*//*195:*/
#line 2756 "parsetree.w"
typedef struct comp_assignment_node*comp_assignment;
typedef struct field_assignment_node*fld_assignment;/*:195*//*208:*/
#line 2959 "parsetree.w"
typedef struct sequence_node*sequence;/*:208*/
#line 119 "parsetree.w"


enum expr_kind
{/*22:*/
#line 381 "parsetree.w"
integer_denotation,string_denotation,boolean_denotation,/*:22*//*29:*/
#line 511 "parsetree.w"
applied_identifier,
last_value_computed,break_expr,return_expr,
die_expr,/*:29*//*40:*/
#line 648 "parsetree.w"
tuple_display,list_display,/*:40*//*54:*/
#line 851 "parsetree.w"
function_call,/*:54*//*65:*/
#line 1014 "parsetree.w"
negation_expr,/*:65*//*90:*/
#line 1463 "parsetree.w"
let_expr,/*:90*//*105:*/
#line 1663 "parsetree.w"
lambda_expr,rec_lambda_expr,/*:105*//*116:*/
#line 1828 "parsetree.w"
conditional_expr,/*:116*//*124:*/
#line 1914 "parsetree.w"
int_case_expr0,int_case_expr1,int_case_expr2,/*:124*//*129:*/
#line 2029 "parsetree.w"
union_case_expr,discrimination_expr,/*:129*//*147:*/
#line 2270 "parsetree.w"
while_expr,for_expr,cfor_expr,/*:147*//*157:*/
#line 2424 "parsetree.w"
subscription,slice,/*:157*//*167:*/
#line 2545 "parsetree.w"
cast_expr,/*:167*//*177:*/
#line 2614 "parsetree.w"
op_cast_expr,/*:177*//*187:*/
#line 2686 "parsetree.w"
ass_stat,/*:187*//*197:*/
#line 2794 "parsetree.w"
comp_ass_stat,field_ass_stat,/*:197*//*210:*/
#line 2985 "parsetree.w"
seq_expr,next_expr,do_expr,/*:210*/
#line 122 "parsetree.w"
no_expr};
typedef struct expr*expr_p;
struct expr{
expr_kind kind;
union{/*21:*/
#line 375 "parsetree.w"
bool bool_denotation_variant;
std::string str_denotation_variant;/*:21*//*30:*/
#line 519 "parsetree.w"
id_type identifier_variant;
unsigned break_variant;
expr_p return_variant;/*:30*//*39:*/
#line 639 "parsetree.w"
raw_expr_list sublist;/*:39*//*55:*/
#line 857 "parsetree.w"
app call_variant;/*:55*//*66:*/
#line 1018 "parsetree.w"
expr*negation_variant;/*:66*//*91:*/
#line 1469 "parsetree.w"
let let_variant;/*:91*//*106:*/
#line 1667 "parsetree.w"
lambda lambda_variant;
rec_lambda rec_lambda_variant;/*:106*//*117:*/
#line 1834 "parsetree.w"
cond if_variant;/*:117*//*135:*/
#line 2101 "parsetree.w"
disc disc_variant;/*:135*//*148:*/
#line 2276 "parsetree.w"
w_loop while_variant;
f_loop for_variant;
c_loop cfor_variant;/*:148*//*158:*/
#line 2429 "parsetree.w"
sub subscription_variant;
slc slice_variant;/*:158*//*168:*/
#line 2549 "parsetree.w"
cast cast_variant;/*:168*//*178:*/
#line 2618 "parsetree.w"
op_cast op_cast_variant;/*:178*//*188:*/
#line 2690 "parsetree.w"
assignment assign_variant;/*:188*//*198:*/
#line 2799 "parsetree.w"
comp_assignment comp_assign_variant;
fld_assignment field_assign_variant;/*:198*//*211:*/
#line 2989 "parsetree.w"
sequence sequence_variant;/*:211*/
#line 126 "parsetree.w"
};
source_location loc;/*12:*/
#line 237 "parsetree.w"
expr():kind(no_expr),loc(){}
expr(const expr&x)=delete;
expr&operator=(const expr&x)=delete;
~expr();
void clear();/*:12*//*16:*/
#line 290 "parsetree.w"
void set_from(expr&other);
expr(expr&&other);
void operator=(expr&&other);
void swap(expr&other);/*:16*//*23:*/
#line 394 "parsetree.w"
struct int_tag{};
struct bool_tag{};
struct string_tag{};
expr(bool b,const YYLTYPE&loc,bool_tag)
:kind(boolean_denotation),bool_denotation_variant(b),loc(loc){}
expr(std::string&&s,const YYLTYPE&loc,int_tag)
:kind(integer_denotation)
,str_denotation_variant(std::move(s))
,loc(loc){}
expr(std::string&&s,const YYLTYPE&loc,string_tag)
:kind(string_denotation)
,str_denotation_variant(std::move(s))
,loc(loc){}/*:23*//*31:*/
#line 527 "parsetree.w"
struct identifier_tag{};
struct dollar_tag{};
struct break_tag{unsigned depth;};
struct return_tag{};
struct die_tag{};

expr(id_type id,const YYLTYPE&loc,identifier_tag)
:kind(applied_identifier),identifier_variant(id),loc(loc){}
expr(const YYLTYPE&loc,dollar_tag)
:kind(last_value_computed),loc(loc){}
expr(const YYLTYPE&loc,break_tag t)
:kind(break_expr),break_variant(t.depth),loc(loc){}
expr(expr_p exp,const YYLTYPE&loc,return_tag t)
:kind(return_expr),return_variant(exp),loc(loc){}
expr(const YYLTYPE&loc,die_tag)
:kind(die_expr),loc(loc){}/*:31*//*41:*/
#line 659 "parsetree.w"
struct tuple_display_tag{};struct list_display_tag{};
expr(expr_list&&nodes,tuple_display_tag,const YYLTYPE&loc)
:kind(tuple_display)
,sublist(nodes.release())
,loc(loc)
{}
expr(expr_list&&nodes,list_display_tag,const YYLTYPE&loc)
:kind(list_display)
,sublist(nodes.release())
,loc(loc)
{}
expr(expr_list&&nodes,tuple_display_tag,const source_location&loc)
:kind(tuple_display)
,sublist(nodes.release())
,loc(loc)
{}
expr(expr_list&&nodes,tuple_display_tag);/*:41*//*56:*/
#line 866 "parsetree.w"
expr(app fx,const YYLTYPE&loc)
:kind(function_call)
,call_variant(fx)
,loc(loc)
{}
expr(app fx,const source_location&loc)
:kind(function_call)
,call_variant(fx)
,loc(loc)
{}/*:56*//*67:*/
#line 1022 "parsetree.w"
struct negate_tag{};
expr(expr*p,const YYLTYPE&loc,negate_tag)
:kind(negation_expr)
,negation_variant(p)
,loc(loc)
{}/*:67*//*92:*/
#line 1473 "parsetree.w"
expr(let declaration,const YYLTYPE&loc)
:kind(let_expr)
,let_variant(declaration)
,loc(loc)
{}/*:92*//*107:*/
#line 1672 "parsetree.w"
expr(lambda fun,const YYLTYPE&loc)
:kind(lambda_expr)
,lambda_variant(fun)
,loc(loc)
{}
expr(rec_lambda fun,const YYLTYPE&loc)
:kind(rec_lambda_expr)
,rec_lambda_variant(fun)
,loc(loc)
{}/*:107*//*118:*/
#line 1840 "parsetree.w"
expr(expr_kind which,cond conditional,const YYLTYPE&loc)
:kind(which)
,if_variant(conditional)
,loc(loc)
{}/*:118*//*136:*/
#line 2107 "parsetree.w"
expr(disc discrimination,const YYLTYPE&loc)
:kind(discrimination_expr)
,disc_variant(discrimination)
,loc(loc)
{}/*:136*//*149:*/
#line 2282 "parsetree.w"
expr(w_loop loop,const YYLTYPE&loc)
:kind(while_expr)
,while_variant(loop)
,loc(loc)
{}
expr(f_loop loop,const YYLTYPE&loc)
:kind(for_expr)
,for_variant(loop)
,loc(loc)
{}
expr(c_loop loop,const YYLTYPE&loc)
:kind(cfor_expr)
,cfor_variant(loop)
,loc(loc)
{}/*:149*//*159:*/
#line 2435 "parsetree.w"
expr(sub s,const YYLTYPE&loc)
:kind(subscription)
,subscription_variant(s)
,loc(loc)
{}
expr(sub s,const source_location&loc)
:kind(subscription)
,subscription_variant(s)
,loc(loc)
{}
expr(slc s,const YYLTYPE&loc)
:kind(slice)
,slice_variant(s)
,loc(loc)
{}/*:159*//*169:*/
#line 2553 "parsetree.w"
expr(cast c,const YYLTYPE&loc)
:kind(cast_expr)
,cast_variant(c)
,loc(loc)
{}/*:169*//*179:*/
#line 2622 "parsetree.w"
expr(op_cast c,const YYLTYPE&loc)
:kind(op_cast_expr)
,op_cast_variant(c)
,loc(loc)
{}/*:179*//*189:*/
#line 2694 "parsetree.w"
expr(assignment a,const YYLTYPE&loc)
:kind(ass_stat)
,assign_variant(a)
,loc(loc)
{}/*:189*//*199:*/
#line 2804 "parsetree.w"
expr(comp_assignment ca,const YYLTYPE&loc)
:kind(comp_ass_stat)
,comp_assign_variant(ca)
,loc(loc)
{}

expr(fld_assignment fa,const YYLTYPE&loc)
:kind(field_ass_stat)
,field_assign_variant(fa)
,loc(loc)
{}/*:199*//*212:*/
#line 2993 "parsetree.w"
expr(sequence s,unsigned which,const YYLTYPE&loc)
:kind(which==0?seq_expr:which==1?next_expr:do_expr)
,sequence_variant(s)
,loc(loc)
{}/*:212*/
#line 129 "parsetree.w"

};
typedef std::unique_ptr<expr>expr_ptr;/*53:*/
#line 840 "parsetree.w"
struct application_node
{expr fun;expr arg;

application_node(expr&&fun,expr&&arg)
:fun(std::move(fun)),arg(std::move(arg)){}
};/*:53*//*74:*/
#line 1169 "parsetree.w"
struct formula_node
{expr left_subtree;expr op_exp;int prio;
formula_node(expr&&l,expr&&o,int prio)
:left_subtree(std::move(l)),op_exp(std::move(o)),prio(prio){}
formula_node(const formula_node&x)=delete;
formula_node(formula_node&&x)=delete;
};

typedef containers::sl_node<formula_node> *raw_form_stack;
struct form_stack:public containers::stack<formula_node>
{using base=containers::stack<formula_node>;
using sub_base=containers::mirrored_simple_list<formula_node>;
using ssub_base=containers::simple_list<formula_node>;

form_stack():base(){}
form_stack(raw_form_stack s):base{sub_base{ssub_base{s}}}{}

raw_form_stack release(){return c.release();}

};/*:74*//*89:*/
#line 1450 "parsetree.w"
struct let_pair{id_pat pattern;expr val;};
typedef containers::simple_list<let_pair>let_list;
typedef containers::sl_node<let_pair> *raw_let_list;

struct let_expr_node
{id_pat pattern;expr val;expr body;

let_expr_node(id_pat&&pattern,expr&&val,expr&&body)
:pattern(std::move(pattern)),val(std::move(val)),body(std::move(body)){}
};/*:89*//*104:*/
#line 1640 "parsetree.w"
struct lambda_node
{id_pat pattern;type_expr parameter_type;expr body;

lambda_node(id_pat&&pattern,type_expr&&type,expr&&body)
:pattern(std::move(pattern))
,parameter_type(std::move(type))
,body(std::move(body))
{}
};

struct rec_lambda_node:public lambda_node
{
id_type self;
type_expr result_type;

rec_lambda_node
(id_type self,id_pat&&pattern,type_expr&&pt,expr&&body,type_expr&&rt)
:lambda_node(std::move(pattern),std::move(pt),std::move(body))
,self(self),result_type(std::move(rt)){}
};/*:104*//*115:*/
#line 1814 "parsetree.w"
struct conditional_node
{expr condition;containers::sl_node<expr>branches;

conditional_node(expr&&condition,expr&&then_branch,expr&&else_branch)
:condition(std::move(condition))
,branches(std::move(then_branch))
{branches.next.reset(new
containers::sl_node<expr>(std::move(else_branch)));
}/*125:*/
#line 1921 "parsetree.w"
conditional_node(expr&&condition,containers::sl_node<expr> &&branches)
:condition(std::move(condition))
,branches(std::move(branches))
{}/*:125*/
#line 1823 "parsetree.w"

};/*:115*//*133:*/
#line 2066 "parsetree.w"
struct case_variant
{id_type label;
id_pat pattern;
expr branch;
};
typedef containers::simple_list<case_variant>case_list;
typedef containers::sl_node<case_variant> *raw_case_list;

struct discrimination_node
{expr subject;containers::sl_node<case_variant>branches;

discrimination_node(expr&&subject,raw_case_list branches);
};/*:133*//*146:*/
#line 2235 "parsetree.w"
struct while_node
{expr body;
BitSet<2>flags;

while_node(expr&&body,unsigned flags)
:body(std::move(body))
,flags(flags){}

};
struct for_node
{id_pat id;expr in_part;expr body;
BitSet<2>flags;

for_node(id_pat&&id,expr&&in_part,expr&&body,unsigned flags)
:id(std::move(id))
,in_part(std::move(in_part))
,body(std::move(body))
,flags(flags){}
};
struct cfor_node
{id_type id;expr count;expr bound;expr body;
BitSet<3>flags;

cfor_node
(id_type id,expr&&count,expr&&bound,expr&&body,unsigned flags)
:id(id)
,count(std::move(count))
,bound(std::move(bound))
,body(std::move(body))
,flags(flags){}
};/*:146*//*156:*/
#line 2403 "parsetree.w"
struct subscription_node
{expr array;expr index;bool reversed;

subscription_node(expr&&array,expr&&index,bool reversed)
:array(std::move(array))
,index(std::move(index))
,reversed(reversed){}
};
struct slice_node
{expr array;expr lower,upper;BitSet<3>flags;

slice_node(expr&&array,expr&&lower,expr&&upper,unsigned flags)
:array(std::move(array))
,lower(std::move(lower))
,upper(std::move(upper))
,flags(flags)
{}
};/*:156*//*166:*/
#line 2533 "parsetree.w"
struct cast_node
{type_expr type;expr exp;

cast_node(type_expr&&type,expr&&exp)
:type(std::move(type))
,exp(std::move(exp)){}

};/*:166*//*176:*/
#line 2602 "parsetree.w"
struct op_cast_node
{id_type oper;type_expr type;

op_cast_node(id_type oper,type_expr&&type)
:oper(oper)
,type(std::move(type)){}

};/*:176*//*186:*/
#line 2672 "parsetree.w"
struct assignment_node
{id_pat lhs;expr rhs;

assignment_node(id_type lhs,expr&&rhs)
:lhs(lhs)
,rhs(std::move(rhs)){}
assignment_node(id_pat&&lhs,expr&&rhs)
:lhs(std::move(lhs))
,rhs(std::move(rhs)){}
};/*:186*//*196:*/
#line 2769 "parsetree.w"
struct comp_assignment_node
{id_type aggr;expr index;expr rhs;bool reversed;

comp_assignment_node(id_type aggr,expr&&index,expr&&rhs,bool reversed)
:aggr(aggr)
,index(std::move(index))
,rhs(std::move(rhs))
,reversed(reversed)
{}
};

struct field_assignment_node
{id_type aggr,selector;expr rhs;

field_assignment_node(id_type aggr,id_type selector,expr&&rhs)
:aggr(aggr)
,selector(selector)
,rhs(std::move(rhs))
{}
};/*:196*//*209:*/
#line 2968 "parsetree.w"
struct sequence_node
{expr first;expr last;

sequence_node(expr&&first,expr&&last)
:first(std::move(first))
,last(std::move(last)){}

};/*:209*//*:4*//*218:*/
#line 3064 "parsetree.w"
typedef struct{id_type id;type_p type;patlist fields;}typedef_struct;

typedef containers::simple_list<typedef_struct>typedef_list;
typedef atlas::containers::sl_node<typedef_struct> *raw_typedef_list;/*:218*/
#line 48 "parsetree.w"

}
}
#endif/*:1*/
